# LSAT types problem ideas

### Building Space
A new seven story building has five companies who wish to rent space. Only one company can rent a given floor. 
A company may rent more than one floor, but the floors must be adjacent.  
Companies are labelled A, B, C, D, and E and floors are labeled from 1, 2, 3, 4, and 5.
All floors must be rented. Not all companies need to have a space.

Each company has a number of location requirements:
No company will rent more than 3 floors. (example clues)
If A or B rents floor 1 then D or E will rent floor 7.
A must be at least two floors away from B.
C must be at a lower level than A.
D must be at least two floors away from C.
E must rent at least two floors.
D and E have exactly two floors between their offices.
D must rent at least as many floors as C.
B does not rent floors 2, 3, or 4.
C has office space adjacent to B.

Problems:
1. If C rents floor 4 what must be true?
2. Which of the following configurations of rental space is viable?
3. If a new company F becomes available to rent space but floors two and three are empty due to construction which of the following configurations is feasible?
4. If company A decided not to rent, what must be true of a feasible plan.

### Performance
A company is planning its performance schedule over a 12 week period. 
It has four venues: New York, DC, Pittsburg, and Atlanta to choose from.
Each week they must perform in exactly one venue. 

The schedule rules are as follows:
No performance can occur in the same venue two weeks in row.
The company must perform in each venue at least twice.
The company must perform in New York twice in the first four weeks and no more than once in the last four weeks.
If the company performs in DC it must perform in Pittsburg two weeks later.
In between the two trips to Atlanta, the company must perform at least one trip in Pittsburg.
The company cannot perform in Atlanta until it performs in DC.

Problems:
1. If the company performs during week 1 in New York what city can it not perform in in week 7?
2. Between trips to Pittsburg, what is the longest number of weeks.
3. If the company changes its rules and instead is allowed to perform in the same city multiple times in a row. There is one schedule in which it performs in a single city three weeks in a row, which city is that?
4. If the company performs in New York on Week 5 and 7 what must be true?

### Vacation
Six friends are deciding what vacations to go on. Each friend (1, 2, 3, 4, 5, and 6) will go on exactly one of three vacations A,B, or C. The decision to go on each vacation will depend upon if that person got a raise that year as well as who else is going or not going on that vacation.

The rules are as follows
If 1 or 3 get a raise then they will not go on A.
If 2 or 4 get a raise they will not go on B.
Whatever vacation 3 goes on 5 will not go on.
Either nobody goes on vacation C or at least three people go on C.
If 5 gets a raise then 1 will not get a raise.
If 5 gets a raise then 5 will not go on C.
1 will go on vacation with either 2 or 4.
If 3 goes on B then 4 will go on A.

Problems:
1. If 4 goes on vacation C then what must be true.
2. If 2 does not go on vacation A what must be true.
